Lucene++ - a full-featured, c++ search engine
API Documentation

Public Member Functions | Static Public Member Functions
Lucene::FilteredQuery Class Reference

A query that applies a filter to the results of another query. More...

`#include <FilteredQuery.h>`

Inheritance diagram for Lucene::FilteredQuery:

## Public Member Functions

| FilteredQuery (const QueryPtr &query, const FilterPtr &filter)
| Constructs a new query which applies a filter to the results of the original query. Filter::getDocIdSet() will be called every time this query is used in a search. More...
virtual | ~FilteredQuery ()
virtual String | getClassName ()
boost::shared_ptr< FilteredQuery > | shared_from_this ()
virtual WeightPtr | createWeight (const SearcherPtr &searcher)
| Returns a Weight that applies the filter to the enclosed query's Weight. This is accomplished by overriding the Scorer returned by the Weight. More...
virtual QueryPtr | rewrite (const IndexReaderPtr &reader)
| Rewrites the wrapped query. More...
QueryPtr | getQuery ()
FilterPtr | getFilter ()
virtual void | extractTerms (SetTerm terms)
| Adds all terms occurring in this query to the terms set. Only works if this query is in its rewritten form. More...
virtual String | toString (const String &field)
| Prints a user-readable version of this query. More...
virtual bool | equals (const LuceneObjectPtr &other)
| Return whether two objects are equal. More...
virtual int32_t | hashCode ()
| Return hash code for this object. More...
virtual LuceneObjectPtr | clone (const LuceneObjectPtr &other=LuceneObjectPtr())
| Returns a clone of this query. More...
virtual String | toString (const String &field)
| Prints a query to a string, with field assumed to be the default field and omitted. More...
virtual String | toString ()
| Prints a query to a string. More...
Public Member Functions inherited from Lucene::Query
| Query ()
virtual | ~Query ()
boost::shared_ptr< Query > | shared_from_this ()
virtual void | setBoost (double b)
| Sets the boost for this query clause to b. Documents matching this clause will (in addition to the normal weightings) have their score multiplied by b. More...
virtual double | getBoost ()
| Gets the boost for this clause. Documents matching this clause will (in addition to the normal weightings) have their score multiplied by b. The boost is 1.0 by default. More...
virtual String | toString ()
| Prints a query to a string. More...
virtual WeightPtr | weight (const SearcherPtr &searcher)
| Constructs and initializes a Weight for a top-level query. More...
virtual QueryPtr | combine (Collection< QueryPtr > queries)
| Called when re-writing queries under MultiSearcher. More...
virtual SimilarityPtr | getSimilarity (const SearcherPtr &searcher)
| Returns the Similarity implementation to be used for this query. Subclasses may override this method to specify their own Similarity implementation, perhaps one that delegates through that of the Searcher. By default the Searcher's Similarity implementation is returned. More...
String | boostString ()
| Return given boost value as a string. More...
Public Member Functions inherited from Lucene::LuceneObject
virtual | ~LuceneObject ()
virtual void | initialize ()
| Called directly after instantiation to create objects that depend on this object being fully constructed. More...
virtual int32_t | compareTo (const LuceneObjectPtr &other)
| Compare two objects. More...
Public Member Functions inherited from Lucene::LuceneSync
virtual | ~LuceneSync ()
virtual SynchronizePtr | getSync ()
| Return this object synchronize lock. More...
virtual LuceneSignalPtr | getSignal ()
| Return this object signal. More...
virtual void | lock (int32_t timeout=0)
| Lock this object using an optional timeout. More...
virtual void | unlock ()
| Unlock this object. More...
virtual bool | holdsLock ()
| Returns true if this object is currently locked by current thread. More...
virtual void | wait (int32_t timeout=0)
| Wait for signal using an optional timeout. More...
virtual void | notifyAll ()
| Notify all threads waiting for signal. More...

## Static Public Member Functions

static String | _getClassName ()
Static Public Member Functions inherited from Lucene::Query
static String | _getClassName ()
static QueryPtr | mergeBooleanQueries (Collection< BooleanQueryPtr > queries)
| Merges the clauses of a set of BooleanQuery's into a single BooleanQuery. More...

## Additional Inherited Members

Protected Member Functions inherited from Lucene::LuceneObject
| LuceneObject ()
Protected Attributes inherited from Lucene::Query
double | boost
Protected Attributes inherited from Lucene::LuceneSync
SynchronizePtr | objectLock
LuceneSignalPtr | objectSignal

## Detailed Description

A query that applies a filter to the results of another query.

Note: the bits are retrieved from the filter each time this query is used in a search - use a CachingWrapperFilter to avoid regenerating the bits every time.

See also
  CachingWrapperFilter

## Constructor & Destructor Documentation

## ◆ FilteredQuery()

Lucene::FilteredQuery::FilteredQuery | ( | const QueryPtr & | query,
|  | const FilterPtr & | filter
| ) |  |

Constructs a new query which applies a filter to the results of the original query. Filter::getDocIdSet() will be called every time this query is used in a search.

Parameters

  query | Query to be filtered, cannot be null.
  filter | Filter to apply to query results, cannot be null.

## ◆ ~FilteredQuery()

virtual Lucene::FilteredQuery::~FilteredQuery | ( |  | ) |

virtual

## Member Function Documentation

## ◆ _getClassName()

static String Lucene::FilteredQuery::_getClassName | ( |  | ) |

inline static

## ◆ clone()

virtual LuceneObjectPtr Lucene::FilteredQuery::clone | ( | const LuceneObjectPtr & | other = `LuceneObjectPtr()` | ) |

virtual

Returns a clone of this query.

Reimplemented from Lucene::Query.

## ◆ createWeight()

virtual WeightPtr Lucene::FilteredQuery::createWeight | ( | const SearcherPtr & | searcher | ) |

virtual

Returns a Weight that applies the filter to the enclosed query's Weight. This is accomplished by overriding the Scorer returned by the Weight.

Reimplemented from Lucene::Query.

## ◆ equals()

virtual bool Lucene::FilteredQuery::equals | ( | const LuceneObjectPtr & | other | ) |

virtual

Return whether two objects are equal.

Reimplemented from Lucene::Query.

## ◆ extractTerms()

virtual void Lucene::FilteredQuery::extractTerms | ( | SetTerm | terms | ) |

virtual

Adds all terms occurring in this query to the terms set. Only works if this query is in its rewritten form.

Reimplemented from Lucene::Query.

## ◆ getClassName()

virtual String Lucene::FilteredQuery::getClassName | ( |  | ) |

inline virtual

Reimplemented from Lucene::Query.

## ◆ getFilter()

FilterPtr Lucene::FilteredQuery::getFilter | ( |  | ) |

## ◆ getQuery()

QueryPtr Lucene::FilteredQuery::getQuery | ( |  | ) |

## ◆ hashCode()

virtual int32_t Lucene::FilteredQuery::hashCode | ( |  | ) |

virtual

Return hash code for this object.

Reimplemented from Lucene::Query.

## ◆ rewrite()

virtual QueryPtr Lucene::FilteredQuery::rewrite | ( | const IndexReaderPtr & | reader | ) |

virtual

Rewrites the wrapped query.

Reimplemented from Lucene::Query.

## ◆ shared_from_this()

boost::shared_ptr< FilteredQuery > Lucene::FilteredQuery::shared_from_this | ( |  | ) |

inline

## ◆ toString() [1/3]

virtual String Lucene::Query::toString

Prints a query to a string.

## ◆ toString() [2/3]

virtual String Lucene::Query::toString

Prints a query to a string, with field assumed to be the default field and omitted.

The representation used is one that is supposed to be readable by QueryParser. However, there are the following limitations:

If the query was created by the parser, the printed representation may not be exactly what was parsed. For example, characters that need to be escaped will be represented without the required backslash.

Some of the more complicated queries (eg. span queries) don't have a representation that can be parsed by QueryParser.

## ◆ toString() [3/3]

virtual String Lucene::FilteredQuery::toString | ( | const String & | field | ) |

virtual

Prints a user-readable version of this query.

Reimplemented from Lucene::Query.

The documentation for this class was generated from the following file:

- FilteredQuery.h

clucene.sourceforge.net